=== modified file 'bzrlib/tests/test_transport.py'
--- bzrlib/tests/test_transport.py	2007-02-01 05:03:16 +0000
+++ bzrlib/tests/test_transport.py	2007-02-02 01:34:27 +0000
@@ -350,6 +350,14 @@
         transport.clone('foo/bar')
         self.assertEqual([('clone', 'foo/bar')] , decorated_transport.calls)
 
+    def test_clone_multiple_levels(self):
+        url='chroot+memory:///hello/'
+        transport = get_transport(url)
+        transport = transport.clone("subdir1")
+        transport = transport.clone("subdir2")
+        self.assertEqual(
+            'chroot+memory:///hello/subdir1/subdir2/', transport.base)
+
     def test_delete(self):
         transport = get_transport('chroot+memory:///foo/bar')
         self.assertRaises(PathNotChild, transport.delete, '/foo')

=== modified file 'bzrlib/tests/test_urlutils.py'
--- bzrlib/tests/test_urlutils.py	2007-02-01 05:03:16 +0000
+++ bzrlib/tests/test_urlutils.py	2007-02-02 01:34:27 +0000
@@ -247,6 +247,9 @@
 
         # Test joining with an absolute path
         test('/bar', 'foo', '/bar')
+
+        # Test joining to a path with a trailing slash
+        test('foo/bar', 'foo/', 'bar')
         
         # Invalid joinings
         # Cannot go above root

=== modified file 'bzrlib/urlutils.py'
--- bzrlib/urlutils.py	2007-02-01 05:03:16 +0000
+++ bzrlib/urlutils.py	2007-02-02 01:34:27 +0000
@@ -170,6 +170,7 @@
     if base == '/':
         path = ['']
     else:
+        base = base.rstrip('/')
         path = base.split('/')
     for arg in args:
         if arg.startswith('/'):

